-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------

function Storm:StartActivity()
   print("START! -- Storm:StartActivity()!");
   StormTimer = Timer();
   STime = math.random(30000) + 45000;
   ActivityMan.ActivityState = Activity.EDITING;
   intensity = 0.5;

    for player = 0, self.PlayerCount - 1 do
        -- Check if we already have a brain assigned
        if not self:GetPlayerBrain(player) then
                self.ActivityState = Activity.EDITING;
                    playerActor = CreateAHuman("Ronin Soldier");
                   playerActor.Pos = Vector(600,450);
                   playerActor.Team = 0;
                   playerActor:AddInventoryItem(CreateHDFirearm("Medium Digger"));
                   MovableMan:AddActor(playerActor);
                   self:SetPlayerBrain(playerActor, 0);
                   self:SetLandingZone(playerActor.Pos, 0);
                   self:SwitchToActor(playerActor, 0, self:GetTeamOfPlayer(0));
            local foundBrain = MovableMan:GetUnassignedBrain(self:GetTeamOfPlayer(player));
            -- If we can't find an unassigned brain in the scene to give each player, then force to go into editing mode to place one
            if not foundBrain then
                playerActor = CreateAHuman("Ronin Soldier");
               playerActor.Pos = Vector(600,450);
               playerActor.Team = 0;
               playerActor:AddInventoryItem(CreateHDFirearm("Medium Digger"));
               MovableMan:AddActor(playerActor);
               self:SetPlayerBrain(playerActor, 0);
               self:SetLandingZone(playerActor.Pos, 0);
               self:SwitchToActor(playerActor, 0, self:GetTeamOfPlayer(0));
            else
                -- Set the found brain to be the selected actor at start
                self:SetPlayerBrain(foundBrain, player);
                self:SwitchToActor(foundBrain, player, self:GetTeamOfPlayer(player));
                self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
                -- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
                self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
            end
        end
    end
end

-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------

function Storm:PauseActivity(pause)
   print("PAUSE! -- Storm:PauseActivity()!");
end

-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------

function Storm:EndActivity()
   print("END! -- Storm:EndActivity()!");
end

----------------------------------------------------------------------------------------------------------
-- Update Activity
----------------------------------------------------------------------------------------------------------

function Storm:UpdateActivity()
   if StormTimer:LeftTillSimMS(STime) < 10000 and StormTimer:LeftTillSimMS(STime) > 0 then
      FrameMan:ClearScreenText(Activity.PLAYER_1);
      FrameMan:SetScreenText("STORM IN " .. math.ceil(StormTimer:LeftTillSimMS(STime)/1000) .. " SECONDS", Activity.PLAYER_1, 0, 5000, false);
   end

   if StormTimer:LeftTillSimMS(STime) < 500 and StormTimer:LeftTillSimMS(STime) > -500 then
      FrameMan:ClearScreenText(Activity.PLAYER_1);
      FrameMan:SetScreenText("Storm Imminent", Activity.PLAYER_1, 0, 5000, false);
   end

   if StormTimer:LeftTillSimMS(STime) < 0 then
      if math.random() < intensity then
         local SandP = CreateAEmitter("Desert Plasma");
         SandP.Pos = Vector(SceneMan.Scene.Width * PosRand(), SceneMan.Scene.Height * PosRand())
         SandP.Vel.X = -math.random(150) - 50;
         SandP.Vel.Y = -math.random(35) + 40;
         SandP.Team = -1;
         MovableMan:AddMO(SandP);
      end
      if StormTimer:LeftTillSimMS(STime) < -20000 then
         StormTimer:Reset();
         STime = math.random(10000) + 45000;
      end
   end
end